#ifndef ANSFD_H
#define ANSFD_H
#pragma once
#include <string.h>
#include <vector>
#include <iostream>
#include <typeinfo>
#include "ANSEngineCommon.h"
#include "SCRFDFaceDetector.h"
#include "ANSOVFaceDetector.h"

namespace ANSCENTER {
    class ANSENGINE_API ANSFD :public ANSODBase {
    public:
        virtual bool Initialize(std::string licenseKey, ModelConfig modelConfig, const std::string& modelZipFilePath, const std::string& modelZipPassword, std::string& labelMap) override;
        virtual bool LoadModel(const std::string& modelZipFilePath, const std::string& modelZipPassword)override;
        virtual bool LoadModelFromFolder(std::string licenseKey, ModelConfig modelConfig, std::string modelName, std::string className, const std::string& modelFolder, std::string& labelMap)override;
        virtual bool OptimizeModel(bool fp16, std::string& optimizedModelFolder);
        std::vector<Object> RunInference(const cv::Mat& input);
        std::vector<Object> RunInference(const cv::Mat& input, const std::string& camera_id);

        bool Destroy();
        ~ANSFD();
    private:
        std::string     _modelFilePath;
        ANSSCRFDFD      _gpufaceDetector;
        ANSOVFD		    _cpufaceDetector;
        EngineType      _engineType;
    };
}
#endif